Bug 120434 - incomplete upgrade leaves system unbootable
incomplete upgrade leaves system unbootable
Status: CLOSED WORKSFORME
Product: Fedora
Classification: Fedora
Component: sysvinit (Show other bugs)
1
All Linux
medium Severity medium
: ---
: ---
Assigned To: Bill Nottingham
David Lawrence
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2004-04-08 15:35 EDT by Lee Olsen
Modified: 2014-03-16 22:44 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-01-28 01:33:32 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lee Olsen 2004-04-08 15:35:55 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.4.1)
Gecko/20031030

Description of problem:
/sbin/init is dynamically linked. Upgrades that change libc.so
or ld-linux.so may cause init to crash on startup. Upgrading
Redhat 7.3 (glibc 2.2.5) to Fedora Core (glibc 2.3.2) does this.
Upgrading glibc, glibc-devel, and bin-utils from 2.2.5 to 2.3.2
at the command line will do the same thing.

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.Start with a clean glibc 2.2.5 system
2.Upgrade glibc, glibc-devel, and bin-utils to 2.3.2
3.
    

Actual Results:  rpm seg faults, preventing upgrades or downgrades.
/sbin/init may or may not run. Trying chroot in
rescue mode seg faults

Additional info:

Programs used at boot time like /sbin/init should be statically linked,
as system upgrades are not atomic and can leave shared objects in
unpredictable and incompatible states.
Rpm and any support tools (like cpio) should be statically linked as well.
Comment 1 Bill Nottingham 2004-04-08 16:03:51 EDT
[notting@nostromo: ~]$ file /usr/lib/rpm/rpmi
/usr/lib/rpm/rpmi: ELF 32-bit LSB executable, Intel 80386, version 1
(SYSV), for GNU/Linux 2.2.5, for GNU/Linux 2.2.5, for GNU/Linux 2.2.5,
statically linked, stripped

That is statically linked. init has never been statically linked to
the best of my knowledge, and this is the first I've heard of this.
Just the glibc upgrade caused the crash for you.
Comment 2 Bill Nottingham 2004-04-08 16:04:09 EDT
Erm, that last statement was a question.
Comment 3 Bill Nottingham 2005-01-28 01:33:32 EST
Closing, no response. Note that glibc does reexec init on upgrades.
Comment 4 David Lawrence 2007-06-21 22:11:14 EDT
Package name is now sysvinit in Fedora.

Note You need to log in before you can comment on or make changes to this bug.